| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 1 | #!/usr/bin/env bash |
| 2 | |
| 3 | ## |
| 4 | # Copyright 2020 ATOS |
| 5 | # |
| 6 | # All Rights Reserved. |
| 7 | # |
| 8 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 9 | # you may not use this file except in compliance with the License. |
| 10 | # You may obtain a copy of the License at |
| 11 | # |
| 12 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 13 | # |
| 14 | # Unless required by applicable law or agreed to in writing, software |
| 15 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 16 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 17 | # See the License for the specific language governing permissions and |
| 18 | # limitations under the License. |
| 19 | ## |
| 20 | |
| 21 | cat /dev/zero | ssh-keygen -q -N "" > /dev/null |
| 22 | |
| 23 | install_osmclient(){ |
| 24 | echo -e "\nInstalling osmclient ${OSMCLIENT}" |
| 25 | python3 -m pip install git+https://osm.etsi.org/gerrit/osm/osmclient@${OSMCLIENT} |
| 26 | } |
| 27 | |
| 28 | download_packages(){ |
| 29 | echo -e "\nDownloading packages ${PACKAGES}" |
| 30 | rm -rf ${PACKAGES_FOLDER} |
| 31 | git clone https://osm.etsi.org/gitlab/vnf-onboarding/osm-packages.git ${PACKAGES_FOLDER} && (cd ${PACKAGES_FOLDER} && \ |
| 32 | git checkout ${PACKAGES}) |
| 33 | } |
| 34 | |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 35 | download_tst010(){ |
| 36 | # Fetch conformance tests |
| 37 | git clone --single-branch --branch ${NFV_TESTS_BRANCH} https://forge.etsi.org/rep/nfv/api-tests.git /robot-systest/conformance-tests/repo |
| 38 | python3 -m pip install -r /robot-systest/conformance-tests/repo/requirements.txt |
| 39 | } |
| 40 | |
| Felipe Vicens | 55b6158 | 2020-06-24 21:23:44 +0200 | [diff] [blame] | 41 | create_vim(){ |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 42 | |
| 43 | attempts=3 |
| 44 | while [ $attempts -ge 0 ] ; do |
| 45 | echo -e "\n$( date '+%F_%H:%M:%S' ) Creating VIM ${VIM_TARGET}" |
| 46 | osm vim-create --name ${VIM_TARGET} --user ${OS_USERNAME} --password ${OS_PASSWORD} --tenant ${OS_PROJECT_NAME} \ |
| 47 | --auth_url ${OS_AUTH_URL} --account_type openstack --description vim \ |
| 48 | --config "{management_network_name: ${VIM_MGMT_NET}, dataplane_physical_net: ${DATAPLANE:-physnet2}}" || true |
| 49 | STATUS="PROCESSING" |
| 50 | i=0 |
| 51 | while [[ ${STATUS} != "ENABLED" ]] |
| 52 | do |
| 53 | ((i++)) |
| 54 | if [[ $i -eq 5 ]]; then |
| 55 | echo "VIM stuck in PROCESSING after 50 seconds" |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 56 | osm vim-delete --force ${VIM_TARGET} |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 57 | sleep 5 |
| 58 | break |
| 59 | fi |
| 60 | sleep 10 |
| 61 | STATUS=`osm vim-list --long | grep ${VIM_TARGET} | awk '{print $9}'` |
| 62 | done |
| 63 | if [[ ${STATUS} = "ENABLED" ]] ; then |
| 64 | break |
| Felipe Vicens | 02300c0 | 2020-07-02 12:19:28 +0200 | [diff] [blame] | 65 | fi |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 66 | ((attempts--)) |
| Felipe Vicens | 02300c0 | 2020-07-02 12:19:28 +0200 | [diff] [blame] | 67 | done |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 68 | |
| 69 | if [ $attempts -lt 0 ] ; then |
| 70 | echo "VIM failed to enter ENABLED state" |
| 71 | exit 1 |
| 72 | fi |
| Felipe Vicens | 55b6158 | 2020-06-24 21:23:44 +0200 | [diff] [blame] | 73 | } |
| 74 | |
| beierlm | 9fc2b84 | 2020-06-26 14:57:09 -0400 | [diff] [blame] | 75 | |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 76 | PARAMS="" |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 77 | RUN_CONFORMANCE_TESTS=false |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 78 | |
| 79 | while (( "$#" )); do |
| 80 | case "$1" in |
| 81 | -t|--testingtags) |
| 82 | TEST=$2 |
| 83 | shift 2 |
| 84 | ;; |
| 85 | -p|--packagesbranch) |
| 86 | PACKAGES=$2 && download_packages |
| 87 | shift 2 |
| 88 | ;; |
| 89 | -o|--osmclientversion) |
| Felipe Vicens | 24e3d15 | 2020-06-25 21:52:06 +0200 | [diff] [blame] | 90 | OSMCLIENT=$2 && install_osmclient |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 91 | shift 2 |
| 92 | ;; |
| Felipe Vicens | 55b6158 | 2020-06-24 21:23:44 +0200 | [diff] [blame] | 93 | -c|--createvim) |
| 94 | create_vim |
| 95 | shift 1 |
| 96 | ;; |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 97 | -T) |
| 98 | NFV_TESTS_BRANCH=$2 && download_tst010 |
| 99 | RUN_CONFORMANCE_TESTS=true |
| 100 | shift 1 |
| 101 | ;; |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 102 | -h|--help) |
| 103 | echo "OSM TESTS TOOL |
| 104 | |
| 105 | Usage: |
| 106 | docker run --rm=true -t osmtests --env-file <env_file> \\ |
| Felipe Vicens | 5c54d27 | 2020-06-23 15:55:08 +0200 | [diff] [blame] | 107 | -v <path_to_reports>:/reports osmtests \\ |
| 108 | -v <path_to_clouds.yaml>:/robot-systest/clouds.yaml \\ |
| 109 | -v <path_to_kubeconfig>:/root/.kube/config \\ |
| 110 | -o <osmclient_version> \\ |
| 111 | -p <package_branch> \\ |
| 112 | -t <testing_tags> |
| Felipe Vicens | 6366c68 | 2020-06-25 20:12:16 +0200 | [diff] [blame] | 113 | |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 114 | Options: |
| 115 | --env-file: It is the environmental file where is described the OSM target and VIM |
| 116 | -o <osmclient_version> [OPTIONAL]: It is used to specify a particular osmclient version. Default: latest |
| 117 | -p <package_branch> [OPTIONAL]: OSM packages repository branch. Default: master |
| 118 | -t <testing_tags> [OPTIONAL]: Robot tests tags. [sanity, regression, particular_test]. Default: sanity |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 119 | -T <testing_branch> [OPTIONAL]: Run SOL005 Robot conformance tests |
| Felipe Vicens | 55b6158 | 2020-06-24 21:23:44 +0200 | [diff] [blame] | 120 | -c To create a VIM for the tests |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 121 | |
| 122 | Volumes: |
| 123 | <path_to_reports> [OPTIONAL]: It is the absolute path to reports location in the host |
| Felipe Vicens | 5c54d27 | 2020-06-23 15:55:08 +0200 | [diff] [blame] | 124 | <path_to_clouds.yaml> [OPTIONAL]: It is the absolute path to the clouds.yaml file in the host |
| 125 | <path_to_kubeconfig> [OPTIONAL]: It is the kubeconfig file to be used for k8s clusters" |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 126 | |
| 127 | exit 0 |
| 128 | ;; |
| 129 | -*|--*=) |
| 130 | echo "Error: Unsupported flag $1" >&2 |
| 131 | exit 1 |
| 132 | ;; |
| 133 | *) |
| 134 | PARAMS="$PARAMS $1" |
| 135 | shift |
| 136 | ;; |
| 137 | esac |
| 138 | done |
| 139 | |
| 140 | eval set -- "$PARAMS" |
| 141 | |
| Felipe Vicens | 24e3d15 | 2020-06-25 21:52:06 +0200 | [diff] [blame] | 142 | if [[ -n "$BRANCH_NAME" ]]; then |
| 143 | PACKAGES=$BRANCH_NAME && download_packages |
| 144 | OSMCLIENT=$BRANCH_NAME && install_osmclient |
| Felipe Vicens | 6366c68 | 2020-06-25 20:12:16 +0200 | [diff] [blame] | 145 | fi |
| 146 | |
| Frank Bryden | e570b10 | 2020-09-07 08:45:54 +0000 | [diff] [blame] | 147 | |
| 148 | if [ "$RUN_CONFORMANCE_TESTS" = true ] ; then |
| 149 | python3 ${ROBOT_DEVOPS_FOLDER}/conformance-tests/run_conformance_tests.py |
| 150 | fi |
| 151 | |
| Felipe Vicens | 6366c68 | 2020-06-25 20:12:16 +0200 | [diff] [blame] | 152 | if [[ -z "${TEST}" ]]; then |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 153 | printf "Test not provided. \nRunning default test: sanity\n" |
| 154 | TEST="sanity" |
| 155 | fi |
| 156 | |
| Felipe Vicens | 6366c68 | 2020-06-25 20:12:16 +0200 | [diff] [blame] | 157 | if [[ -n "${TEST}" ]]; then |
| Felipe Vicens | f96bb45 | 2020-06-22 08:12:30 +0200 | [diff] [blame] | 158 | robot -d ${ROBOT_DEVOPS_FOLDER}/reports -i ${TEST} ${ROBOT_DEVOPS_FOLDER}/testsuite/ |
| 159 | exit 0 |
| 160 | else |
| 161 | echo "Wrong test provided" |
| 162 | exit 1 |
| 163 | fi |
| 164 | |
| 165 | exit 1 |